library flutter_dialog_box;
import 'package:flutter/material.dart';

/// todo:风格1
class FlutterDialog extends StatefulWidget {
  double circular;//圆角
  double spacingLR;//容器左右
  double height;//弹出框高度
  double titleHeight;//标题栏高度
  double btnHeight;
  Widget title;//标题
  String leftText;//左侧文件
  String rightText;//右侧文件
  Widget centerWidget;//中间文本
  ValueChanged valueChanged;//普通确定取消对话框回调
  FlutterDialog({Key key,
    this.height:200,
    this.circular:7,
    this.centerWidget,
    this.leftText:"取消",
    this.rightText:"确定",
    this.spacingLR:60,
    this.title,
    this.titleHeight:45,
    this.btnHeight:45,
    this.valueChanged
  }) : super(key : key);
  @override
  _FlutterDialogState createState() => _FlutterDialogState();
}

class _FlutterDialogState extends State<FlutterDialog> {
  @override
  void initState() {
    // TODO: implement initState
    super.initState();
    if (widget.centerWidget==null) {
      widget.centerWidget=Text("内容");
    }
    if (widget.title==null) {
      widget.title=Text("标题");
    }
  }
  @override
  Widget build(BuildContext context) {
    return Material(
      color: Colors.transparent,
      child: Center(
        ///todo：圆角容器
        child: new ClipRRect(
          borderRadius: BorderRadius.circular(widget.circular),
          child: Container(
            width: MediaQuery.of(context).size.width - widget.spacingLR,
            height: widget.height,
            color: Colors.white,
            child: Column(
              children: <Widget>[

                ///todo:标题
                Container(
                  child: widget.title,
                  padding: EdgeInsets.all(10),
                  height: widget.titleHeight,
                  alignment: Alignment.centerLeft,
                ),

                ///todo:横线
                Container(height: 1,color: Colors.grey[200],),

                ///todo:数据展示区域
                Container(
                  padding: EdgeInsets.all(10),
                  //内容区高度 = （标题-下划线-底部按钮行）
                  height: widget.height-(2+widget.titleHeight+widget.btnHeight),
                  child: widget.centerWidget,
                ),

                ///todo:横线
                Container(height: 1,color: Colors.grey[200],),

                //按钮
                Container(
                  height: widget.btnHeight,
                  color: Colors.deepPurpleAccent,
                  child: Row(
                    children: <Widget>[
                      Expanded(
                        child:InkWell(
                          child: Container(
                            child: Text("取消"),
                            alignment: Alignment.center,
                            color: Colors.white,
                          ),
                          onTap: (){
                            print("左侧按钮");
                            widget.valueChanged("no");
                            Navigator.pop(context);
                          },
                        ),
                      ),
                      Container(height: 40,width: 1,color: Colors.grey[200],),
                      Expanded(
                        child:InkWell(
                          child: Container(
                            child: Text("确定"),
                            alignment: Alignment.center,
                            color: Colors.white,
                          ),
                          onTap: (){
                            print("右侧按钮");
                            widget.valueChanged( "ok");
                            Navigator.pop(context);
                          },
                        ),
                      ),
                    ],
                  ),
                ),
              ],
            ),
          ),
        ),
      ),
    );
  }
}

/// todo:风格2
class FlutterDialog1 extends StatefulWidget {
  @override
  _FlutterDialog1State createState() => _FlutterDialog1State();
}

class _FlutterDialog1State extends State<FlutterDialog1> {
  @override
  Widget build(BuildContext context) {
    return Container();
  }
}

/// todo:风格3
class FlutterDialog2 extends StatefulWidget {
  @override
  _FlutterDialog2State createState() => _FlutterDialog2State();
}

class _FlutterDialog2State extends State<FlutterDialog2> {
  @override
  Widget build(BuildContext context) {
    return Container();
  }
}


